
Redmine - Defect #5969

Attachments with size zero are ignored

2010-07-27 06:29 - Yuriy Vidineev

Status: Closed Start date: 2010-07-27

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Attachments Estimated time: 0.00 hour

Target version:    

Resolution: Fixed Affected version:  

Description

How to reproduce:

- create file with zero size (for example, in Linux: touch redmine_test_file.txt)

- try to add this file to existing issue

Results:Issue has not any uploaded file

I have Redmine 1.0.0 on Debian Lenny with mongrel and MySQL 5.0

Ruby version              1.8.7 (x86_64-linux)

RubyGems version          1.3.4

Rack version              1.0

Rails version             2.3.5

Active Record version     2.3.5

Active Resource version   2.3.5

Action Mailer version     2.3.5

Active Support version    2.3.5

Application root          /var/www/redmine-1.0.0

Database adapter          mysql

Database schema version   20100705164950

About your Redmine plugins

Redmine Graphs plugin    0.1.0

Simple CI                1.0

Redmine Charts           0.1.0

Scrumdashboard plugin    1.2

Mylyn Connector plugin   2.6.4.trunk.423

In production.log i can see this:

Processing IssuesController#update (for X.X.X.X at 2010-07-27 08:05:14) [PUT]

Parameters: {"time_entry"=>{"comments"=>"", "activity_id"=>"", "hours"=>""}, "commit"=>"Принять", "notes"=>"", "action"=>"update",

"_method"=>"put", "authenticity_token"=>"Kieyq

oJZuBzsxZldQfF/7ijY4Dj4U4EWWDss06SHiSo=", "id"=>"10758", "issue"=>{"start_date"=>"2010-07-26",

"custom_field_values"=>{"8"=>"2010-07-27"}, "estimated_hours"=>"", "priority_id"=>"6

", "parent_issue_id"=>"", "lock_version"=>"8", "fixed_version_id"=>"", "done_ratio"=>"0", "assigned_to_id"=>"8", "subject"=>"Test

Task ", "category_id"=>"126", "tracker_id"=>"14", "due_date"=>"", "status_id"=>"2", "description"=>"Test Test"},

"controller"=>"issues", "attachments"=>{"1"=>{"file"=>#<File:/tmp/RackMultipart20100727-28985-l0uv9f-0>, "description"=>"test

file"}}}

Redirected to http://prj.slweb.ru/issues/10758

Completed in 340ms (DB: 48) | 302 Found [http://prj.slweb.ru/issues/10758/edit]

If i do:

echo 1 > redmine_test_file.txt

then this file can be added successfully.

P.S. Sorry for my English

Thank you!

Related issues:

Related to Redmine - Patch #23718: do not ignore zero byte attachments Closed
http://prj.slweb.ru/issues/10758/edit


Related to Redmine - Patch #25115: Support upload of empty files and fix inva... Closed

Has duplicate Redmine - Defect #10312: Can not attach empty files. Closed

History

#1 - 2010-07-27 09:46 - Felix Schäfer

If this updates adds an empty file, I can't reproduce the issue.

#2 - 2010-07-27 09:48 - Felix Schäfer

- Subject changed from Could not upload file with zero size into existing issue to Attachments with size zero are ignored

- Category set to Attachments

- Affected version (unused) set to devel

Ok, my precedent note should have included an empty attachment, so I can reproduce this issue.

#3 - 2010-07-27 13:26 - Holger Just

This is because of source:trunk/app/models/attachment.rb#L147

Attachments with size zero are explicitly ignored.

#4 - 2010-07-27 13:44 - Felix Schäfer

Any reason for not uploading null-sized attachments, or on the other hand any reason for wanting to upload null-sized files?

#5 - 2010-08-06 08:03 - Yuriy Vidineev

We want to upload google verification files - files with special name and zero size

#6 - 2010-08-06 08:39 - Felix Schäfer

IIRC google verification files have to live in the root of the URI you want to verify, for that you'd need to put the file in redmine_dir/public/.

#7 - 2010-08-06 08:47 - Yuriy Vidineev

I may not correctly put. I don't wont to verify my Redmine. I want to verify my another website and add google verification file to task in Redmine. But i

can't add this file to task because it has zero size.

P.S. Sorry for my English

#8 - 2010-08-06 09:14 - Felix Schäfer

Well, you could just save the filename in a wiki or wherever, and I think google retains means to download the files even long after they have been

activated ;-)

Anyway, Holger, do you see any reason to not allow zero-sized files?

#9 - 2010-08-06 10:28 - Holger Just

I still do not see the point why you would want that. Also, the file you downloaded from google is not a zero byte file. It at least contains the code that

is also present in the filename.

But I see no technical reasons why a zero byte file would not be possible, apart from possibly obscure browser bugs of course. Also, I just traced the

code back to the initial revision, so we can also safely fall back to "we always did it that way" :) See 

source:trunk/redmine/app/controllers/documents_controller.rb@4#L46

#10 - 2013-01-15 10:30 - Daniel Felix

- Status changed from New to Needs feedback

Any news on this? Should this be corrected or is this excluded by design?

#11 - 2013-01-15 22:17 - Jean-Philippe Lang

- Status changed from Needs feedback to Confirmed

I mark this as confirmed as there's no good reason to ignore empty files.

#12 - 2015-04-06 16:12 - Go MAEDA

- Has duplicate Defect #10312: Can not attach empty files. added
#13 - 2015-04-15 17:46 - Stephen Ostrow

Felix Schäfer wrote:

Any reason for not uploading null-sized attachments, or on the other hand any reason for wanting to upload null-sized files?

 Figured I would add another use-case as an example and why I went looking to see if this bug was already filed. Over the past month or so I've been

uploading 4 files when running an operation.

1. before.txt

2. operation.log

3. after.txt

4. result.diff

Where result.diff is a diff of the before.txt and the after.txt files. When there is no difference then the .diff file is empty (0b) and although I still want it

uploaded to show that fact, redmine is silently ignoring the upload.

I personally would like for redmine to upload 0b files since I can't think of a good reason for it not to. But more so I would say it is a bug that it silently

ignores the 0b file after showing you that it has been added to the issue.

#14 - 2016-08-30 14:24 - Jens Krämer

Submitted a patch that fixes this in #23718

#15 - 2016-08-31 03:23 - Jens Krämer

- File 0001-allow-upload-of-zero-byte-files-as-attachments.patch added

attaching the patch here as requested :)

#16 - 2016-08-31 09:26 - Jan from Planio www.plan.io

- Related to Patch #23718: do not ignore zero byte attachments added

#17 - 2016-08-31 09:28 - Jan from Planio www.plan.io

- Target version set to Candidate for next minor release

#18 - 2017-02-18 03:15 - Go MAEDA

- Related to Patch #25115: Support upload of empty files and fix invalid API response added

#19 - 2017-03-01 01:15 - Go MAEDA

- Status changed from Confirmed to Closed

- Target version deleted (Candidate for next minor release)

- Resolution set to Fixed

Fixed by #25115 for 3.3.3 and 3.4.0.

Files

0001-allow-upload-of-zero-byte-files-as-attachments.patch 2.92 KB 2016-08-31 Jens Krämer
